(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('tslib'), require('@ts-ioc/core'), require('@ts-ioc/bootstrap'), require('path'), require('@ts-ioc/platform-server'), require('fs')) :
	typeof define === 'function' && define.amd ? define(['tslib', '@ts-ioc/core', '@ts-ioc/bootstrap', 'path', '@ts-ioc/platform-server', 'fs'], factory) :
	(global['platform-server-bootstrap'] = global['platform-server-bootstrap'] || {}, global['platform-server-bootstrap'].js = factory(global.tslib,global['@ts-ioc/core'],global['@ts-ioc/bootstrap'],global.path,global['@ts-ioc/platform-server'],global.fs));
}(this, (function (tslib_1,core,bootstrap_1,path,platformServer,fs) { 'use strict';

tslib_1 = tslib_1 && tslib_1.hasOwnProperty('default') ? tslib_1['default'] : tslib_1;
core = core && core.hasOwnProperty('default') ? core['default'] : core;
bootstrap_1 = bootstrap_1 && bootstrap_1.hasOwnProperty('default') ? bootstrap_1['default'] : bootstrap_1;
path = path && path.hasOwnProperty('default') ? path['default'] : path;
platformServer = platformServer && platformServer.hasOwnProperty('default') ? platformServer['default'] : platformServer;
fs = fs && fs.hasOwnProperty('default') ? fs['default'] : fs;

function commonjsRequire () {
	throw new Error('Dynamic requires are not currently supported by rollup-plugin-commonjs');
}

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var BootstrapModule = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });





let ConfigureFileLoader = class ConfigureFileLoader {
    constructor(baseURL, container) {
        this.baseURL = baseURL;
        this.container = container;
    }
    async load(uri) {
        const fs$$1 = fs;
        if (uri) {
            if (fs$$1.existsSync(uri)) {
                return commonjsRequire(uri);
            }
            else if (fs$$1.existsSync(path.join(this.baseURL, uri))) {
                return commonjsRequire(path.join(this.baseURL, uri));
            }
            else {
                console.log(`config file: ${uri} not exists.`);
                return null;
            }
        }
        else {
            let cfgmodeles;
            let cfgpath = path.join(this.baseURL, './config');
            ['.js', '.ts', '.json'].forEach(ext => {
                if (cfgmodeles) {
                    return false;
                }
                if (fs$$1.existsSync(cfgpath + ext)) {
                    cfgmodeles = commonjsRequire(cfgpath + ext);
                    return false;
                }
                return true;
            });
            return cfgmodeles;
        }
    }
};
ConfigureFileLoader.classAnnations = { "name": "ConfigureFileLoader", "params": { "constructor": ["baseURL", "container"], "load": ["uri"] } };
ConfigureFileLoader = tslib_1.__decorate([
    core.Injectable(bootstrap_1.ConfigureLoaderToken),
    tslib_1.__metadata("design:paramtypes", [String, Object])
], ConfigureFileLoader);
exports.ConfigureFileLoader = ConfigureFileLoader;
/**
 * server app.
 *
 * @export
 * @template T
 * @param {string} [baseURL]
 * @returns {IApplicationBuilderServer<T>}
 */
function serverApp(baseURL) {
    return new bootstrap_1.ApplicationBuilder(baseURL).use(ServerBootstrapModule);
}
exports.serverApp = serverApp;
let cwd = process.cwd();
let processRoot = path.join(path.dirname(cwd), path.basename(cwd));
/**
 * server boot module
 *
 * @export
 * @class ServerBootstrapModule
 */
let ServerBootstrapModule = class ServerBootstrapModule {
};
ServerBootstrapModule.classAnnations = { "name": "ServerBootstrapModule", "params": {} };
ServerBootstrapModule = tslib_1.__decorate([
    bootstrap_1.DIModule({
        imports: [
            platformServer.ServerModule,
            ConfigureFileLoader
        ],
        providers: [
            { provide: bootstrap_1.ProcessRunRootToken, useValue: processRoot }
        ],
        exports: [
            ConfigureFileLoader
        ]
    })
], ServerBootstrapModule);
exports.ServerBootstrapModule = ServerBootstrapModule;


});

unwrapExports(BootstrapModule);
var BootstrapModule_1 = BootstrapModule.ConfigureFileLoader;
var BootstrapModule_2 = BootstrapModule.serverApp;
var BootstrapModule_3 = BootstrapModule.ServerBootstrapModule;

var D__Workspace_github_node_tsioc_packages_platformServerBootstrap_esnext = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });

tslib_1.__exportStar(BootstrapModule, exports);


});

var index = unwrapExports(D__Workspace_github_node_tsioc_packages_platformServerBootstrap_esnext);

return index;

})));

//# sourceMappingURL=sourcemaps/platform-server-bootstrap.js.map
